package xml_demo;

import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

/**
 *
 * @author ronchet
 */
public class XML_Element {
    Student create() {
        

//Create the student oject
        Student s1 = new Student();
        s1.setId(1);
        s1.setFirstName("Michelangelo");
        s1.setLastName("Buonarroti");
        s1.setYear(2);
        return s1;
    }
    void marshal(Student student, String fileName){ 
        JAXBContext jaxbContext;
        try {
            jaxbContext = JAXBContext.newInstance(Student.class);
            Marshaller jaxbMarshaller = jaxbContext.createMarshaller();
            jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
            //Marshal the students list in console
            jaxbMarshaller.marshal(student, System.out);
            //Marshal the students list in file
            jaxbMarshaller.marshal(student, new File(fileName));
        } catch (JAXBException ex) {
            System.err.println(ex);
        }
    }

    Student unmarshal(String fileName) {
        Student stud = null;
        JAXBContext jaxbContext;
        try {
            jaxbContext = JAXBContext.newInstance(Student.class);
            Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
            //We had written this file in marshalling example
            stud = (Student) jaxbUnmarshaller.unmarshal(new File(fileName));
        } catch (JAXBException ex) {
            System.err.println(ex);
        }
        return stud;
    }


    public XML_Element() {
        // NOTA: la directory in cui si trova il file deve essere settata
        // come working directory nelle proprietà di progetto, sezione run
        final String fileName="/Users/ronchet/Downloads/Test/student.xml";
        System.out.println("==> creo l'elemento");
        Student student=create();
        System.out.println("==> lo salvo in un file in forma xml");
        marshal(student,fileName);
        //
        System.out.println("==> leggo il file ed estraggo l'elemento");
        Student s = unmarshal(fileName);
            System.out.println(s.getId());
            System.out.println(s.getFirstName());
        
    }
    public static void main(String[] args) {
        new XML_Element();
    }
}
