package xml_demo;

import java.io.File;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

/**
 *
 * @author ronchet
 */
public class XML_List {
    Students create() {
        Students students = new Students();
        students.setStudents(new ArrayList<Student>());

//Initialize the students list
        students.setStudents(new ArrayList<Student>());
        //Create two students
        Student s1 = new Student();
        s1.setId(1);
        s1.setFirstName("Michelangelo");
        s1.setLastName("Buonarroti");
        s1.setYear(2);

        Student s2 = new Student();
        s2.setId(2);
        s2.setFirstName("Raffaello");
        s2.setLastName("Sanzio");
        s2.setYear(1);

        //Add the students in list
        students.getStudents().add(s1);
        students.getStudents().add(s2);
        return students;
    }
    void marshal(Students students, String fileName){ 
        JAXBContext jaxbContext;
        try {
            jaxbContext = JAXBContext.newInstance(Students.class);
            Marshaller jaxbMarshaller = jaxbContext.createMarshaller();
            jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
            //Marshal the students list in console
            jaxbMarshaller.marshal(students, System.out);
            //Marshal the students list in file
            jaxbMarshaller.marshal(students, new File(fileName));
        } catch (JAXBException ex) {
            System.err.println(ex);
        }
    }

    Students unmarshal(String fileName) {
        Students studs = null;
        JAXBContext jaxbContext;
        try {
            jaxbContext = JAXBContext.newInstance(Students.class);
            Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
            //We had written this file in marshalling example
            studs = (Students) jaxbUnmarshaller.unmarshal(new File(fileName));
        } catch (JAXBException ex) {
            System.err.println(ex);
        }
        return studs;
    }


    public XML_List() {
        // NOTA: la directory in cui si trova il file deve essere settata
        // come working directory nelle proprietà di progetto, sezione run
        final String fileName="/Users/ronchet/Downloads/Test/students.xml";
        System.out.println("==> creo gli elementi");
        Students studentGroup=create();
        System.out.println("==> li salvo in un file in forma xml");
        marshal(studentGroup,fileName);
        //
        System.out.println("==> leggo il file ed estraggo gli elementi");
        Students studs = unmarshal(fileName);
        for (Student s : studs.getStudents()) {
            System.out.println(s.getId());
            System.out.println(s.getFirstName());
        }
    }
    public static void main(String[] args) {
        new XML_List();
    }
}
